package users

import (
	db "ttime/internal/database"

	"github.com/gofiber/fiber/v2"
	"github.com/gofiber/fiber/v2/log"
)

func GetAllUsersProject(c *fiber.Ctx) error {
	// Get all users from a project
	projectName := c.Params("projectName")
	users, err := db.GetDb(c).GetAllUsersProject(projectName)
	if err != nil {
		log.Info("Error getting users from project:", err) // Debug print
		return c.Status(500).SendString(err.Error())
	}

	log.Info("Returning all users")
	// Return the list of users as JSON
	return c.JSON(users)
}
