import { projDescHighLimit, projDescLowLimit } from "../../Data/constants";

export default function DescriptionInput(props: {
  desc: string;
  placeholder: string;
  onChange: (e: React.ChangeEvent<HTMLInputElement>) => void;
}): JSX.Element {
  return (
    <>
      <input
        className={
          props.desc.length <= 100
            ? "border-2 border-green-500 dark:border-green-500 focus-visible:border-green-500 outline-none rounded-2xl w-full py-2 px-3 text-gray-700 leading-tight"
            : "border-2 border-red-600 dark:border-red-600 focus:border-red-600 outline-none rounded-2xl w-full py-2 px-3  text-gray-700 leading-tight"
        }
        spellCheck="true"
        id="New desc"
        type="text"
        placeholder={props.placeholder}
        value={props.desc}
        onChange={props.onChange}
      />
      <div className="my-1">
        {props.desc.length > projDescHighLimit && (
          <p className="text-red-600 pl-2 text-[13px] text-left">
            Description must be under 100 characters
          </p>
        )}
        {props.desc.length <= projDescHighLimit &&
          props.desc.length > projDescLowLimit && (
            <p className="text-green-500 pl-2 text-[13px] text-left">
              Valid project description!
            </p>
          )}
      </div>
    </>
  );
}
