import { passwordLength } from "../../Data/constants";
import { lowercase } from "../../Data/regex";

export default function PasswordInput(props: {
  password: string;
  onChange: (e: React.ChangeEvent<HTMLInputElement>) => void;
}): JSX.Element {
  const password = props.password;
  return (
    <>
      <input
        className={
          password.length === passwordLength && lowercase.test(password)
            ? "border-2 border-green-500 dark:border-green-500 focus-visible:border-green-500 outline-none rounded-2xl w-full py-2 px-3 text-gray-700 leading-tight"
            : "border-2 border-red-600 dark:border-red-600 focus:border-red-600 outline-none rounded-2xl w-full py-2 px-3  text-gray-700 leading-tight"
        }
        spellCheck="false"
        id="New password"
        type="password"
        placeholder="Password"
        value={password}
        onChange={props.onChange}
      />
      <div className="my-1">
        {password.length === passwordLength &&
          lowercase.test(props.password) && (
            <p className="text-green-500 pl-2 text-[13px] text-left">
              Valid password!
            </p>
          )}
        {password.length !== passwordLength && (
          <p className="text-red-600 pl-2 text-[13px] text-left">
            Password must be 6 characters
          </p>
        )}
        {!lowercase.test(password) && password !== "" && (
          <p className="text-red-600 pl-2 text-[13px] text-left">
            No number, uppercase or special <br /> characters allowed
          </p>
        )}
      </div>
    </>
  );
}
