import { usernameLowLimit, usernameUpLimit } from "../../Data/constants";
import { alphanumeric } from "../../Data/regex";

export default function UsernameInput(props: {
  username: string;
  onChange: (e: React.ChangeEvent<HTMLInputElement>) => void;
}): JSX.Element {
  const username = props.username;
  return (
    <>
      <input
        className={
          username.length >= usernameLowLimit &&
          username.length <= usernameUpLimit &&
          alphanumeric.test(props.username)
            ? "border-2 border-green-500 dark:border-green-500 focus-visible:border-green-500 outline-none rounded-2xl w-full py-2 px-3 text-gray-700 leading-tight"
            : "border-2 border-red-600 dark:border-red-600 focus:border-red-600 outline-none rounded-2xl w-full py-2 px-3  text-gray-700 leading-tight"
        }
        spellCheck="false"
        id="New username"
        type="text"
        placeholder="Username"
        value={username}
        onChange={props.onChange}
      />
      <div className="my-1">
        {alphanumeric.test(username) &&
          username.length >= usernameLowLimit &&
          username.length <= usernameUpLimit && (
            <p className="text-green-500 pl-2 text-[13px] text-left">
              Valid username!
            </p>
          )}
        {!alphanumeric.test(username) && username !== "" && (
          <p className="text-red-600 pl-2 text-[13px] text-left">
            No special characters allowed
          </p>
        )}
        {!(
          username.length >= usernameLowLimit &&
          username.length <= usernameUpLimit
        ) && (
          <p className="text-red-600 pl-2 text-[13px] text-left">
            Username must be 5-10 characters
          </p>
        )}
      </div>
    </>
  );
}
