import BasicWindow from "../../Components/BasicWindow";
import Button from "../../Components/Button";
import BackButton from "../../Components/BackButton";
import { UserListAdmin } from "../../Components/UserListAdmin";
import { useNavigate } from "react-router-dom";
import GetAllUsers from "../../Components/GetAllUsers";
import { useState } from "react";

function AdminManageUsers(): JSX.Element {
  const [users, setUsers] = useState<string[]>([]);
  GetAllUsers({ setUsersProp: setUsers });

  const navigate = useNavigate();

  const content = <UserListAdmin users={users} />;

  const buttons = (
    <>
      <Button
        text="Add User"
        onClick={(): void => {
          navigate("/adminAddUser");
        }}
        type="button"
      />
      <BackButton />
    </>
  );

  return <BasicWindow content={content} buttons={buttons} />;
}
export default AdminManageUsers;
